########################################################################
#
#
# $Revision: 2.6 $, $Date: 2000/01/21 07:23:09 $
########################################################################

namespace eval ::nep::configure {
  variable bg;				# copy of background used in
					# entry widgets
}
########################################################################
proc ::nep::checkConfig {gui count} {
  variable bsof
  
  set bs [string trim [$gui.ebs get]]
  if {[catch {incr bs 0}] || $bs>$count} {
    $gui.ebs configure -bg [$gui.ebs cget -selectbackground]
    bell
    return 0
  }
  $gui.ebs delete 0 end
  $gui.ebs insert end $bs
  return 1
}
########################################################################
#
proc ::nep::configPrimaryGui {gui var} {
  label $gui.l -text "file name goes here"

  label $gui.lbs -text blocksize:
  entry $gui.ebs
  set configure::bg [$gui.ebs cget -background]

  label $gui.lComment -text comment:
  entry $gui.eComment

  label $gui.lXlabel -text "xaxis-label:"
  entry $gui.eXlabel
  
  label $gui.lYlabel -text "yaxis-label:"
  entry $gui.eYlabel

  foreach x {ebs eComment eXlabel eYlabel} {
    bind $gui.$x <Return> "$gui.ok invoke"
  }

  ## ok and cancel buttons
  frame $gui.bframe 
  button $gui.ok -text Ok \
      -command "set $var 1"
  button $gui.cancel -text Cancel \
      -command "set $var 0"
  pack $gui.ok $gui.cancel -in $gui.bframe -side left

  grid $gui.l -row 0 -column 0 -sticky n\
      -columnspan 2

  set row 1
  foreach x {bs Comment Xlabel Ylabel} {
    grid $gui.l$x -row $row -column 0 \
	-sticky e
    grid $gui.e$x -row $row -column 1 \
	-sticky ew
    incr row
  }

  grid $gui.bframe -row $row -column 0 \
      -columnspan 2
  grid columnconfigure $gui 0 -weight 0
  grid columnconfigure $gui 1 -weight 1
}
########################################################################
##
##
## Parameter which denotes the entry in $w.eleMenu.m to which all this
## relates. 
##
proc ::nep::configPrimary {w which} {
  variable current
  variable fdof
  variable bsof
  variable modalWait

  ## local shortcuts
  set cur $current($w)
  set fd $fdof($w,$cur)
  set gui $w.configPrimary

  ## compute good screen position and create the gui, if necessary
  set x [expr [winfo rootx $w.g] + 30]
  set y [expr [winfo rooty $w.g]+30]
  if {![winfo exist $gui]} {
    toplevel $gui
    wm title $gui "Configure Plot"
    configPrimaryGui $gui ::nep::modalWait($w)
    wm geometry $gui +$x+$y
  } else {
    wm geometry $gui +$x+$y
    wm deiconify $gui
  }

  ## fill in the current values
  set cur [$w.eleMenu.m entrycget $which -command]
  $gui.l configure -text [::tdfio::getName $fd]
  foreach p {bs Comment Xlabel Ylabel} {
    $gui.e$p delete 0 end
  }
  $gui.ebs insert end $bsof($w,$cur)
  $gui.eComment insert end [::tdfio::get $fd Comment {a plot}]
  $gui.eXlabel insert end [::tdfio::get $fd Xlabel {samples [-]}]
  $gui.eYlabel insert end [::tdfio::get $fd Ylabel {value [-]}]
  
  ## let the user do something
  grab $gui
  tkwait variable ::nep::modalWait($w)
  set count [::tdfio::getCount $fd]
  while {$::nep::modalWait($w) && ![::nep::checkConfig $gui $count]} {
    tkwait variable ::nep::modalWait($w)
  }
  #puts [$gui.ebs configure]
  $gui.ebs configure -bg $configure::bg
  grab release $gui
  wm withdraw $gui

  if {!$modalWait($w)} return

  ## set the current values from the widget
  if {$bsof($w,$cur)!=[$gui.ebs get]} {
    set bsof($w,$cur) [$gui.ebs get]
    deleteAllPos $w
  }
  ::tdfio::hset $fd Comment [$gui.eComment get]
  ::tdfio::hset $fd Xlabel [$gui.eXlabel get]
  ::tdfio::hset $fd Ylabel [$gui.eYlabel get]

  $w.g configure -title [$gui.eComment get]
  $w.g xaxis configure -title [$gui.eXlabel get]
  $w.g yaxis configure -title [$gui.eYlabel get]
  
  calculateCbiAndDx $w
  $w.bscale invoke
}