########################################################################
##
## Teacher -- simple teacher-widget to change a running
##            tcl-application 
## 
## A call like
##    teacher.Create .teacher
## creates a text-widget together with three buttons named 
##    Evaluate X Selection
##    Evaluate Window
##    Clear
## 
## Whenever `Evaluate X Selection' is pressed, teacher clears the
## window, copys the current X-selection into it and evaluates the
## window contents. This allows to mark in an xemacs-window a
## bug-fixed version of a `proc' and have it entered into the running
## application. 
##
## `Evaluate Window' simply evaluates whatever happens to be in the
## window.
##
## `Clear' clears the window

##
## (C) 1997 Harald Kirsch (kir@iitb.fhg.de)
## $Revision: 1.2 $, $Date: 1997/06/28 16:12:43 $
##

########################################################################
proc teacher.Eval {w} {
  set res [uplevel \#0 [$w.t get 1.0 end]]
  set res [string trim $res "\n"]
  regsub -all "\n" $res "\n\#   " res
  $w.t insert end "\n\#   "
  $w.t insert end $res
  $w.t insert end "\n"
}
########################################################################
proc teacher.EvalSelection {w} {
  $w.t delete 1.0 end
  $w.t insert end [selection get]
  teacher.Eval $w
}
########################################################################
proc teacher.Create {w} {
  
  if {[winfo exist $w]} {
    wm deiconify $w
    return
  }

  toplevel $w
  wm minsize $w 1 1
  wm title $w "Teacher of `[wm title .]'"

  text $w.t -height 12 -width 75 \
      -yscrollcommand "$w.scroll set"
  scrollbar $w.scroll -comman "$w.t yview"

  frame $w.bframe
  button $w.evalSel -text "Evaluate X Selection" \
      -command "teacher.EvalSelection $w"
  button $w.eval -text "Evaluate Window" \
      -command "teacher.Eval $w"
  button $w.clear -text Clear \
      -command "$w.t delete 1.0 end"
  pack $w.clear $w.eval $w.evalSel -in $w.bframe  -side left


  grid columnconfigure $w 0 -weight 1
  grid rowconfigure $w 0 -weight 1
  grid $w.t -sticky nswe \
      -row 0 -column 0
  grid $w.scroll -sticky ns \
      -row 0 -column 1
  grid $w.bframe -columnspan 2 \
      -row 1
  
  if { "balloonHelp"=="[info proc balloonHelp]" } {
    balloonHelp $w.evalSel "copies the X selection\
into the window above and executes the window"
    balloonHelp $w.eval "evaluate the window content"
    balloonHelp $w.clear "clear the window"
  }
}
